/**
 * New Payment Gateway APIs
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2022-01-01
 * Contact: nextgenapi@cashfree.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/// <reference types="node" />
import { IncomingHttpHeaders } from 'http';
import { CFAuthorizationRequest } from '../model/cFAuthorizationRequest';
import { CFOrder } from '../model/cFOrder';
import { CFOrderPayResponse } from '../model/cFOrderPayResponse';
import { CFOrderRequest } from '../model/cFOrderRequest';
import { CFPaymentsEntity } from '../model/cFPaymentsEntity';
import { Authentication, Interceptor } from '../model/models';
export declare enum OrdersApiApiKeys {
}
export declare class OrdersApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        default: Authentication;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    set useQuerystring(value: boolean);
    set basePath(basePath: string);
    set defaultHeaders(defaultHeaders: any);
    get defaultHeaders(): any;
    get basePath(): string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: OrdersApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    /**
     * Use this API to create orders with Cashfree from your backend and get the payment link
     * @summary Create Order
     * @param xClientId
     * @param xClientSecret
     * @param xApiVersion
     * @param xIdempotencyReplayed
     * @param xIdempotencyKey
     * @param xRequestId
     * @param cFOrderRequest
     */
    createOrder(xClientId: string, xClientSecret: string, xApiVersion?: string, xIdempotencyReplayed?: boolean | null, xIdempotencyKey?: string, xRequestId?: string, cFOrderRequest?: CFOrderRequest, requestTimeout?: Number, webProxy?: any, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        cfHeaders: IncomingHttpHeaders;
        cfOrder: CFOrder;
    }>;
    /**
     * Use this API to view all details of an order.
     * @summary Get Order
     * @param xClientId
     * @param xClientSecret
     * @param orderId
     * @param xApiVersion
     * @param xIdempotencyReplayed
     * @param xIdempotencyKey
     * @param xRequestId
     */
    getOrder(xClientId: string, xClientSecret: string, orderId: string, xApiVersion?: string, xIdempotencyReplayed?: boolean, xIdempotencyKey?: string, xRequestId?: string, requestTimeout?: Number, webProxy?: any, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        cfHeaders: IncomingHttpHeaders;
        cfOrder: CFOrder;
    }>;
    /**
     * Use this API when you have already created the orders and want Cashfree to process the payment.
     * @summary Order Pay
     * @param xApiVersion
     * @param xRequestId
     * @param cFOrderPayRequest
     */
    orderPay(xApiVersion: string, xRequestId?: string, cFOrderPayRequest?: any, requestTimeout?: Number, webProxy?: any, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        cfHeaders: IncomingHttpHeaders;
        cfOrderPayResponse: CFOrderPayResponse;
    }>;
    /**
     * Use this API when you have already created the orders and want Cashfree to process the payment.
     * @summary Order Pay
     * @param xApiVersion
     * @param xRequestId
     * @param cFOrderPayRequest
     */
    orderSessionPay(xApiVersion: string, xRequestId?: string, cFOrderPayRequest?: any, requestTimeout?: Number, webProxy?: any, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        cfHeaders: IncomingHttpHeaders;
        cfOrderPayResponse: CFOrderPayResponse;
    }>;
    /**
     * Use this API to capture or void a preauthorized payment
     * @summary Preauthorization
     * @param xClientId
     * @param xClientSecret
     * @param orderId
     * @param xApiVersion
     * @param xIdempotencyReplayed
     * @param xIdempotencyKey
     * @param xRequestId
     * @param cFAuthorizationRequest
     */
    preauthorization(xClientId: string, xClientSecret: string, orderId: string, xApiVersion?: string, xIdempotencyReplayed?: boolean, xIdempotencyKey?: string, xRequestId?: string, cFAuthorizationRequest?: CFAuthorizationRequest, requestTimeout?: Number, webProxy?: any, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        cfHeaders: IncomingHttpHeaders;
        cfPaymentsEntity: CFPaymentsEntity;
    }>;
}
