/**
 * New Payment Gateway APIs
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2022-01-01
 * Contact: nextgenapi@cashfree.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/// <reference types="node" />
import http from 'http';
import { CFRefund } from '../model/cFRefund';
import { CFRefundRequest } from '../model/cFRefundRequest';
import { Authentication, Interceptor } from '../model/models';
export declare enum RefundsApiApiKeys {
}
export declare class RefundsApi {
    protected _basePath: string;
    protected _defaultHeaders: any;
    protected _useQuerystring: boolean;
    protected authentications: {
        default: Authentication;
    };
    protected interceptors: Interceptor[];
    constructor(basePath?: string);
    set useQuerystring(value: boolean);
    set basePath(basePath: string);
    set defaultHeaders(defaultHeaders: any);
    get defaultHeaders(): any;
    get basePath(): string;
    setDefaultAuthentication(auth: Authentication): void;
    setApiKey(key: RefundsApiApiKeys, value: string): void;
    addInterceptor(interceptor: Interceptor): void;
    /**
     * Use this API to initiate refunds.
     * @summary Create Refund
     * @param xClientId
     * @param xClientSecret
     * @param orderId
     * @param xApiVersion
     * @param xIdempotencyReplayed
     * @param xIdempotencyKey
     * @param xRequestId
     * @param cFRefundRequest
     */
    createrefund(xClientId: string, xClientSecret: string, orderId: string, xApiVersion?: string, xIdempotencyReplayed?: boolean, xIdempotencyKey?: string, xRequestId?: string, cFRefundRequest?: CFRefundRequest, requestTimeout?: Number, webProxy?: any, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        cfHeaders: http.IncomingHttpHeaders;
        cfRefund: CFRefund;
    }>;
    /**
     * Use this API to fetch a specific refund processed on your Cashfree Account.
     * @summary Get Refund
     * @param xClientId
     * @param xClientSecret
     * @param orderId
     * @param refundId Refund Id of the refund you want to fetch.
     * @param xApiVersion
     * @param xIdempotencyReplayed
     * @param xIdempotencyKey
     * @param xRequestId
     */
    getRefund(xClientId: string, xClientSecret: string, orderId: string, refundId: string, xApiVersion?: string, xIdempotencyReplayed?: boolean, xIdempotencyKey?: string, xRequestId?: string, requestTimeout?: Number, webProxy?: any, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        cfHeaders: http.IncomingHttpHeaders;
        cfRefund: CFRefund;
    }>;
    /**
     * Use this API to fetch all refunds processed against an order.
     * @summary Get All Refunds for an Order
     * @param xClientId
     * @param xClientSecret
     * @param orderId
     * @param xApiVersion
     */
    getallrefundsfororder(xClientId: string, xClientSecret: string, orderId: string, xApiVersion?: string, requestTimeout?: Number, webProxy?: any, options?: {
        headers: {
            [name: string]: string;
        };
    }): Promise<{
        cfHeaders: http.IncomingHttpHeaders;
        cfRefunds: Array<CFRefund>;
    }>;
}
