/**
 * New Payment Gateway APIs
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2022-01-01
 * Contact: nextgenapi@cashfree.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
export declare class CFCard {
    /**
    * The channel for card payments will always be \"link\"
    */
    'channel': string;
    /**
    * Customer card number for plain card transactions. Token pan number for tokenized card transactions.
    */
    'cardNumber': string;
    /**
    * Customer name mentioned on the card.
    */
    'cardHolderName': string;
    /**
    * Card expiry month for plain card transactions. Token expiry month for tokenized card transactions.
    */
    'cardExpiryMm': string;
    /**
    * Card expiry year for plain card transactions. Token expiry year for tokenized card transactions.
    */
    'cardExpiryYy': string;
    /**
    * CVV mentioned on the card.
    */
    'cardCvv': string;
    /**
    * instrument id of saved card. Required only to make payment using saved instrument.
    */
    'instrumentId': string;
    /**
    * cryptogram received from card network. Required only for tokenized card transactions.
    */
    'cryptogram': string;
    /**
    * TRID issued by card networks. Required only for tokenized card transactions.
    */
    'tokenRequestorId': string;
    /**
    * last 4 digits of original card number. Required only for tokenized card transactions.
    */
    'cardDisplay': string;
    /**
    * Card alias as returned by Cashfree Vault API.
    */
    'cardAlias': string;
    /**
    * One of [\"Kotak\", \"ICICI\", \"RBL\", \"BOB\", \"Standard Chartered\"]. Card bank name, required for EMI payments. This is the bank user has selected for EMI
    */
    'cardBankName': CFCard.CardBankNameEnum;
    /**
    * EMI tenure selected by the user
    */
    'emiTenure': number;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace CFCard {
    enum CardBankNameEnum {
        Kotak,
        Icici,
        Rbl,
        Bob,
        StandardChartered,
        Test
    }
}
