/**
 * New Payment Gateway APIs
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2022-01-01
 * Contact: nextgenapi@cashfree.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { CFVendorSplit } from './cFVendorSplit';
export declare class CFRefund {
    /**
    * Cashfree Payments ID of the payment for which refund is initiated
    */
    'cfPaymentId'?: number;
    /**
    * Cashfree Payments ID for a refund
    */
    'cfRefundId'?: string;
    /**
    * Merchant’s order Id of the order for which refund is initiated
    */
    'orderId'?: string;
    /**
    * Merchant’s refund ID of the refund
    */
    'refundId'?: string;
    /**
    * Type of object
    */
    'entity'?: CFRefund.EntityEnum;
    /**
    * Amount that is refunded
    */
    'refundAmount'?: number;
    /**
    * Currency of the refund amount
    */
    'refundCurrency'?: string;
    /**
    * Note added by merchant for the refund
    */
    'refundNote'?: string;
    /**
    * This can be one of [\"SUCCESS\", \"PENDING\", \"CANCELLED\", \"ONHOLD\"]
    */
    'refundStatus'?: CFRefund.RefundStatusEnum;
    /**
    * The bank reference number for refund
    */
    'refundArn'?: string;
    /**
    * Charges in INR for processing refund
    */
    'refundCharge'?: number;
    /**
    * Description of refund status
    */
    'statusDescription'?: string;
    /**
    * Key-value pair that can be used to store additional information about the entity. Maximum 5 key-value pairs
    */
    'metadata'?: object;
    'refundSplits'?: Array<CFVendorSplit>;
    /**
    * This can be one of [\"PAYMENT_AUTO_REFUND\", \"MERCHANT_INITIATED\", \"UNRECONCILED_AUTO_REFUND\"]
    */
    'refundType'?: CFRefund.RefundTypeEnum;
    /**
    * Method or speed of processing refund
    */
    'refundMode'?: CFRefund.RefundModeEnum;
    /**
    * Time of refund creation
    */
    'createdAt'?: string;
    /**
    * Time when refund was processed successfully
    */
    'processedAt'?: string;
    static discriminator: string | undefined;
    static attributeTypeMap: Array<{
        name: string;
        baseName: string;
        type: string;
    }>;
    static getAttributeTypeMap(): {
        name: string;
        baseName: string;
        type: string;
    }[];
}
export declare namespace CFRefund {
    enum EntityEnum {
        Refund
    }
    enum RefundStatusEnum {
        Success,
        Pending,
        Cancelled,
        Onhold
    }
    enum RefundTypeEnum {
        PaymentAutoRefund,
        MerchantInitiated,
        UnreconciledAutoRefund
    }
    enum RefundModeEnum {
        Standard,
        Instant
    }
}
